<template>
  <div>
    <h2 v-if="selectedUsers.length">Selecionados</h2>
    <ol class="participants">
      <li :key="user.id" v-for="(user, index) in selectedUsers" class="user-box">
        <div class="div-user">
          <div class="avatar"/>
          <p class="username">{{user.nome}}</p>
        </div>
        <div class="button-box">
          <Button
            type="button"
            :id="`reject-${index}`"
            :action="changeList"
            buttonType="dangerAlt"
            class="button"
            text="Desfazer"
          />
        </div>
      </li>
    </ol>
    <h2 v-if="users.length">Inscritos</h2>
    <ol class="participants">
      <li :key="user.id" v-for="(user, index) in users" class="user-box">
        <div class="div-user">
          <div class="avatar"/>
          <p class="username">{{user.nome}}</p>
        </div>
        <div class="button-box">
          <Button
            type="button"
            :id="`select-${index}`"
            :action="changeList"
            buttonType="successAlt"
            class="button"
            text="Selecionar"
          />
        </div>
      </li>
    </ol>
    <Button
      type="button"
      id="finish"
      :action="changeRoles"
      buttonType="primaryAlt"
      text="Finalizar"
    />
  </div>
</template>

<script lang="ts">
import Vue from "vue";

import { CHANGE_PARTICIPANT_ROLE_MUTATION } from "./graphql/mutations";

export default Vue.extend({
  data() {
    return {
      users: users.sort(sortingFunction),
      selectedUsers
    };
  },
  created() {
    this.loadParticipants();
  },
  methods: {
    changeList: function(event: any) {
      console.log(this.users);
      console.log(event.target.id);
      const operation = event.target.id.substring(0, 6);

      // quebra pra 10+ usuários - consertar

      const index = parseInt(
        event.target.id.substring(
          event.target.id.length - 1,
          event.target.id.length
        )
      );

      console.log(operation);
      console.log(index);

      switch (operation) {
        case "select":
          const selectedUser = this.users.splice(index, 1)[0];
          console.log(selectedUser);
          this.selectedUsers.push(selectedUser);

          this.selectedUsers = this.selectedUsers.sort(sortingFunction);

          break;
        case "reject":
          const deselectedUser = this.selectedUsers.splice(index, 1)[0];
          this.users.push(deselectedUser);

          this.users = this.users.sort(sortingFunction);

          break;
      }
    },
    loadParticipants: function() {},
    changeRoles: function() {
      selectedUsers.map((value: any, index: number) => {
        this.$apollo.mutate({
          mutation: CHANGE_PARTICIPANT_ROLE_MUTATION,
          variables: {
            id: value.id,
            role: "selected"
          }
        });
      });
    }
  }
});
let users = [
  {
    nome: "Felipe",
    imgUrl: "src",
    id: "101",
    key: "1"
  },
  {
    nome: "Caio",
    imgUrl: "src",
    id: "102",
    key: "2"
  },
  {
    nome: "Raul",
    imgUrl: "src",
    id: "103",
    key: "3"
  },
  {
    nome: "Joedson",
    imgUrl: "src",
    id: "104",
    key: "4"
  }
];

let selectedUsers = [] as any;

let sortingFunction = (a: any, b: any) => {
  var nomeDoPrimeiro = a.name.toLowerCase();
  var nomeDoSegundo = b.name.toLowerCase();
  if (nomeDoPrimeiro < nomeDoSegundo) {
    return -1;
  }
  if (nomeDoPrimeiro > nomeDoSegundo) {
    return 1;
  }
  return 0;
};
</script>
<style>
.participants {
  padding: 0;
}
.avatar {
  margin-right: 15px;
  height: 30px;
  width: 30px;
  border-radius: 100%;
  background-color: black;
}
.username {
  margin: 0;
  padding-top: 4px;
  align-self: center;
}
.user-box {
  height: 40px;
  width: 320px;
  padding: 30px;
  margin-top: 15px;
  display: flex;
  align-items: center;
  justify-content: space-between;
  list-style: none;
  border: solid 1px rgba(0, 0, 0, 0.2);
  border-radius: 2px;
}
.div-user {
  display: flex;
  flex-direction: row;
}
.button-box {
  display: flex;
  flex-direction: column;
}

.button {
  padding: 5px 10px;
  margin-right: 0px;
}

.selection-button {
  background-color: gray;
  border: 1px solid;
}
</style>

